--
-- Four Horsemen Raidwarning AddOn
--  BETA Version !!!
--


LVBM.AddOns.FourHorsemen = {
	["Name"] = LVBM_FOURHORSEMEN_NAME,
	["Abbreviation1"] = "horsemen",
	["Version"] = "0.1",
	["Author"] = "Nitram",
	["Description"] = LVBM_FOURHORSEMEN_INFO,
	["Instance"] = LVBM_NAXX,
	["GUITab"] = LVBMGUI_TAB_NAXX,
	["Sort"] = 23,
	["Options"] = {
		["Enabled"] = true,
		["Announce"] = false,
		["ShowMarkPreWarning"] = true,
	},
	["DropdownMenu"] = {
		[1] = {
			["variable"] = "LVBM.AddOns.FourHorsemen.Options.ShowMarkPreWarning",
			["text"] = LVBM_FOURHORSEMEN_SHOW_5SEC_MARK_WARNING,
			["func"] = function() LVBM.AddOns.FourHorsemen.Options.ShowMarkPreWarning = not LVBM.AddOns.FourHorsemen.Options.ShowMarkPreWarning; end,
		},	
	},
	["Events"] = {
		["CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS"] = true,		-- ShieldWall
		["CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF"] = true,		-- Meteor // Wrath // Void
		["CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"] = true,		-- Meteor // Wrath // Void
		["CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE"] = true,			-- Meteor
		["CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE"] = true,			-- Mark
		["CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE"] = true,	-- Mark
		["CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE"] = true,		-- Mark
	},
	["LastMark"] = 0,
	["CountMark"] = 0,
	["OnCombatStart"] = function(delay)
		LVBM.AddOns.FourHorsemen.LastMark = 0;
		LVBM.AddOns.FourHorsemen.CountMark = 0;
		LVBM.Schedule(20 - 5 - delay, "LVBM.AddOns.FourHorsemen.OnEvent", "MarkWarn5");
		LVBM.StartStatusBarTimer(20 - delay, "Mark");
	end,
	["OnCombatEnd"] = function()
		LVBM.AddOns.FourHorsemen.LastMark = 0;
		LVBM.AddOns.FourHorsemen.CountMark = 0;
	end,
	["OnEvent"] = function(event, arg1)

		-----------------
		-- Mark Debuff --
		-----------------
		if (event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" 
		 or event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE"
		 or event == "CHAT_MSG_SPELL_PERIODIC_PARTY_DAMAGE") then
			if (string.find(arg1, LVBM_FOURHORSEMEN_MARK_EXPR)) then
				if( time() - LVBM.AddOns.FourHorsemen.LastMark > 3 )then
					LVBM.AddOns.FourHorsemen.LastMark = time();
					LVBM.AddOns.FourHorsemen.CountMark = LVBM.AddOns.FourHorsemen.CountMark + 1;
					LVBM.Announce( string.format(LVBM_FOURHORSEMEN_MARK_ANNOUNCE, LVBM.AddOns.FourHorsemen.CountMark) );
					LVBM.Schedule(7, "LVBM.AddOns.FourHorsemen.OnEvent", "MarkWarn5");
					LVBM.StartStatusBarTimer(12, "Mark");
				end
			end
		elseif (event == "MarkWarn5") and LVBM.AddOns.FourHorsemen.Options.ShowMarkPreWarning then
			LVBM.Announce(string.format(LVBM_FOURHORSEMEN_MARK_WARNING, (LVBM.AddOns.FourHorsemen.CountMark+1)));
		end
		
		---------------
		-- Void Zone --
		---------------
		if (event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE"
		 or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF") then
			if (string.find(arg1, LVBM_FOURHORSEMEN_VOID_EXPR)) then		-- Void 
				LVBM.AddSpecialWarning(LVBM_FOURHORSEMEN_VOID_ANNOUNCE);
				LVBM.StartStatusBarTimer(12, "Void Zone", true);
			end			
		end
		
		------------
		-- Meteor --
		------------
		if (event == "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE") then
			if (string.find(arg1, LVBM_FOURHORSEMEN_METEOR_EXPR)) then		-- Meteor 
				LVBM.StartStatusBarTimer(12, "Meteor", true);
			end
		end
		----------------
		-- ShieldWall --
		----------------
		if (event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS") then
			local _, _, sArg1 = string.find(arg1, LVBM_FOURHORSEMEN_SHIELDWALL_EXPR);
			if( sArg1 ) then
				LVBM.Announce(string.format(LVBM_FOURHORSEMEN_SHIELDWALL_ANNOUNCE, sArg1));
				LVBM.Schedule(20, "LVBM.AddOns.FourHorsemen.OnEvent", "ShieldWallWarn5", sArg1);
				--german localization
				sArg1 = string.gsub(sArg1, "Hochlord", "Highlord");
				
				LVBM.StartStatusBarTimer(20, "Shield Wall: "..sArg1);
			end
		elseif (event == "ShieldWallWarn5") then
			LVBM.Announce(string.format(LVBM_FOURHORSEMEN_SHIELDWALL_FADE, arg1));
		end
	end,
}



