--
-- Alterac und Arathi Battleground Mods
--
-- based on v1.0 from LeoLeal,  thanks
-- modivied by Nitram to v1.2 with auto turn-In for alterac valley
-- modivied by Nitram to v1.4 with Arathi Basin Time to End Bar, bugfixes etc.
-- modivied by Nitram to v1.5 with WSG Flag Info Frame and a lot of Bugfixes.
--

LVBM.AddOns.Battlegrounds = { 
	["Name"] = "Battlegrounds", 
	["Abbreviation1"] = "bg", 
	["Version"] = "1.5", 
	["Author"] = "Nitram + LeoLeal", 
	["Description"] = LVBM_BGMOD_LANG.INFO,
	["Instance"] = LVBM_OTHER, 
	["GUITab"] = LVBMGUI_TAB_OTHER, 
	["Sort"] = 0, 
	["Options"] = {
		["Enabled"] = true, 
		["Announce"] = false, 
		["AVAutoTurnIn"] = true, 
		["ShowWsgFrame"] = true,
	}, 
	["DropdownMenu"] = {
		[1] = {
			["variable"] = "LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn", 
			["text"] = LVBM_BGMOD_LANG.AVTURNININFO, 
			["func"] = function() LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn = not LVBM.AddOns.Battlegrounds.Options.AVAutoTurnIn; end, 
		}, 
		[2] = {
			["variable"] = "LVBM.AddOns.Battlegrounds.Options.ShowWsgFrame", 
			["text"] = LVBM_BGMOD_LANG.WSG_INFOFRAME_INFO, 
			["func"] = function() LVBM.AddOns.Battlegrounds.Options.ShowWsgFrame = not LVBM.AddOns.Battlegrounds.Options.ShowWsgFrame; end, 
		}, 
	}, 
	["Events"] = {
		["CHAT_MSG_MONSTER_YELL"] = true,
		["CHAT_MSG_BG_SYSTEM_NEUTRAL"] = true,
		["CHAT_MSG_BG_SYSTEM_ALLIANCE"] = true, 
		["CHAT_MSG_BG_SYSTEM_HORDE"] = true, 
		["PLAYER_ENTERING_WORLD"] = true,
		["ZONE_CHANGED_NEW_AREA"] = true,
		["GOSSIP_SHOW"] = true, 			-- Turn In
		["QUEST_PROGRESS"] = true, 			-- Turn In
		["QUEST_COMPLETE"] = true, 			-- Turn In
		["UPDATE_BATTLEFIELD_SCORE"] = true, 
	}, 	
	["GetItemName"] = function(bag,  slot)
		local itemlink;
		if (bag == -1) then	itemlink = GetInventoryItemLink("player",  slot);
		else			itemlink = GetContainerItemLink(bag,  slot);
		end
		if (itemlink) then
			local _,  _,  name = string.find(itemlink,  "^.*%[(.*)%].*$");
			return name;
		else	return "";
		end
	end, 
	["GetItemCount"] = function(ItemName)
		local anzl,  bagNr,  bagSlot = 0;
		for bagNr = 0,  10,  1 do
			for bagSlot = 1,  GetContainerNumSlots(bagNr),  1 do
				if( LVBM.AddOns.Battlegrounds.GetItemName(bagNr,  bagSlot) == ItemName) then
					local _,  itemCount = GetContainerItemInfo(bagNr,  bagSlot);
					anzl = anzl + itemCount;
				end
			end
		end
		return anzl;
	end, 
	["ABGetScore"] = function()		-- LVBM.AddOns.Battlegrounds.ABGetScore
		if( GetZoneText() == LVBM_BGMOD_LANG.ABZONE ) then
			_, mAllyInfo = GetWorldStateUIInfo(1);
			_, mHordeInfo = GetWorldStateUIInfo(2);
			if( not mAllyInfo or not mHordeInfo ) then return false; end

			_, _, AllyBases, AllyScore = string.find(mAllyInfo, LVBM_BGMOD_LANG.ABSCOREEXP);
			_, _, HordeBases, HordeScore = string.find(mHordeInfo, LVBM_BGMOD_LANG.ABSCOREEXP);
			if( not AllyBases or not AllyScore or not HordeBases or not HordeScore) then return false; end

			AllyBases	= tonumber( AllyBases );
			AllyScore	= tonumber( AllyScore );
			HordeBases	= tonumber( HordeBases );
			HordeScore	= tonumber( HordeScore );

			return true, AllyBases, AllyScore, HordeBases, HordeScore;
		else return false;
		end
	end,
	["ABLastTick"] = {
		["LastAllyCount"] = 0,
		["LastHordeCount"] = 0,
		["Alliance"] = {
			["Score"] = 0,
			["Time"] = 0,
			["Bases"] = 0,
		},
		["Horde"] = {
			["Score"] = 0,
			["Time"] = 0,
			["Bases"] = 0,
		},
	},
	["ABResPerSec"] = function(bases)
		bases = tonumber(bases);
		local value = 0.0;		-- Used values from BGAssist because my times where wrong
		if(bases == 1) then	value = 25.0 / 30.0;		-- 25 res per 30 sec
		elseif(bases == 2) then	value = (300.0 / 9.0) / 30.0; 	-- 33.3(repeating) per 30 sec
		elseif(bases == 3) then	value = 50.0  / 30.0;		-- 50 res per 30 sec
		elseif(bases == 4) then	value = 100.0 / 30.0;		-- 100 res per 30 sec
		elseif(bases == 5) then	value = 900.0 / 30.0;		-- 900 res per 30 sec
		end
		return value;
	end,
	["WSGInfoFrame"] = function(showframe)
		if( LVBMWsgInfoFrame ) then
			if( LVBMWsgInfoFrame:GetObject():IsShown() and not showframe ) then	LVBMWsgInfoFrame:Hide();
			elseif( showframe ) then 						LVBMWsgInfoFrame:Show(); end
		elseif( showframe ) then
			LVBM.AddOns.Battlegrounds.WSGInfoFrameCreate();
		end		
	end,
	["WSGInfoFrameCreate"] = function()
		LVBMWsgInfoFrame = LVBMGui:CreateInfoFrame("Warsong Flag Captures", "Shows the Flag Carrier");
		if( not LVBMWsgInfoFrame ) then 
			LVBM.AddMsg("Can't get Frame from CreateInfoFrame()");
			return false; 
		end

		LVBMWsgInfoFrameAllianceFlag 	= LVBMWsgInfoFrame:CreateStatusBar(0, 1, 1, LVBM_BGMOD_LANG.WSG_ALLYFLAG.."Base");
		LVBMWsgInfoFrameAllianceFlag:GetObject():SetStatusBarColor(0,0,1);
		LVBMWsgInfoFrameAllianceFlag:GetObject():EnableMouse(true);
		LVBMWsgInfoFrameAllianceFlag:GetObject():SetScript("OnMouseUp", function() 
								TargetByName(LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[1], true); 
							end);

		LVBMWsgInfoFrameHordeFlag 	= LVBMWsgInfoFrame:CreateStatusBar(0, 1, 1, LVBM_BGMOD_LANG.WSG_HORDEFLAG.."Base");
		LVBMWsgInfoFrameHordeFlag:GetObject():SetStatusBarColor(1,0,0);
		LVBMWsgInfoFrameHordeFlag:GetObject():EnableMouse(true);
		LVBMWsgInfoFrameHordeFlag:GetObject():SetScript("OnMouseUp", function() 
								TargetByName(LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[2], true); 
							end);
	end,
	["WSGInfoFrameTarget"] = { [1] = "", [2] = "" },
	["OnUpdate"] = function()
		if( GetZoneText() == LVBM_BGMOD_LANG.ABZONE ) then
			local mOk, AllyBases, AllyScore, HordeBases, HordeScore = LVBM.AddOns.Battlegrounds.ABGetScore();
	
			if( mOk and LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Score ~= AllyScore ) then		-- Update Time on Score Change
				LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Score = AllyScore;
				LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Bases = AllyBases;
				LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Time = time();
			end
			if( mOk and LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Score ~= HordeScore ) then
				LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Score = HordeScore;
				LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Bases = HordeBases;
				LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Time = time();
			end
		end
	end,
	["OnEvent"] = function(event,  arg1)

		-- ------------------------ --
		-- WSG InfoFrame - FlagCaps --
		-- ------------------------ --
		if( event == "ZONE_CHANGED_NEW_AREA" and GetZoneText() == LVBM_BGMOD_LANG.WSGZONE ) and LVBM.AddOns.Battlegrounds.Options.ShowWsgFrame then
			LVBM.AddOns.Battlegrounds.WSGInfoFrame(true);

		elseif( event == "ZONE_CHANGED_NEW_AREA" and GetZoneText() ~= LVBM_BGMOD_LANG.WSGZONE and LVBMWsgInfoFrame ) then
			LVBM.AddOns.Battlegrounds.WSGInfoFrame(false);
		end

		if (event == "CHAT_MSG_BG_SYSTEM_ALLIANCE" or event == "CHAT_MSG_BG_SYSTEM_HORDE") and LVBM.AddOns.Battlegrounds.Options.ShowWsgFrame then
			if( LVBMWsgInfoFrame ) then
				if( string.find(arg1, LVBM_BGMOD_LANG.WSG_FLAG_PICKUP) ) then
					local _, _, mSide, mNick =  string.find(arg1, LVBM_BGMOD_LANG.WSG_FLAG_PICKUP);
					if( mSide == LVBM_BGMOD_LANG.ALLIANCE ) then
						LVBMWsgInfoFrameAllianceFlag:SetTitle(LVBM_BGMOD_LANG.WSG_ALLYFLAG..mNick);
						LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[1] = mNick;

					elseif( mSide == LVBM_BGMOD_LANG.HORDE ) then
						LVBMWsgInfoFrameHordeFlag:SetTitle(LVBM_BGMOD_LANG.WSG_HORDEFLAG..mNick);
						LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[2] = mNick;
					end
	
				elseif( string.find(arg1, LVBM_BGMOD_LANG.WSG_FLAG_RETURN) ) then
					local _, _, mSide, mNick =  string.find(arg1, LVBM_BGMOD_LANG.WSG_FLAG_RETURN);
					if( mSide == LVBM_BGMOD_LANG.ALLIANCE ) then
						LVBMWsgInfoFrameAllianceFlag:SetTitle(LVBM_BGMOD_LANG.WSG_ALLYFLAG..LVBM_BGMOD_LANG.WSG_FLAG_BASE);
						LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[1] = "";

					elseif( mSide == LVBM_BGMOD_LANG.HORDE ) then
						LVBMWsgInfoFrameHordeFlag:SetTitle(LVBM_BGMOD_LANG.WSG_HORDEFLAG..LVBM_BGMOD_LANG.WSG_FLAG_BASE);
						LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[2] = "";
					end

				elseif( string.find(arg1, LVBM_BGMOD_LANG.HASCAPTURED) ) then	-- get point
					LVBMWsgInfoFrameAllianceFlag:SetTitle(LVBM_BGMOD_LANG.WSG_ALLYFLAG..LVBM_BGMOD_LANG.WSG_FLAG_BASE);
					LVBMWsgInfoFrameHordeFlag:SetTitle(LVBM_BGMOD_LANG.WSG_HORDEFLAG..LVBM_BGMOD_LANG.WSG_FLAG_BASE);
					LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[1] = "";
					LVBM.AddOns.Battlegrounds.WSGInfoFrameTarget[2] = "";
				end
			end
		end

		----------------
		-- AB WinTime --
		----------------
		if( GetZoneText() == LVBM_BGMOD_LANG.ABZONE ) then

		  	if( LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Score < 2000 
			and LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Score < 2000
			and (LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Score + LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Score) > 0
			and (LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Bases + LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Bases) > 0 ) then

				if( LVBM.AddOns.Battlegrounds.ABLastTick.LastAllyCount ~= LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Bases 
				 or LVBM.AddOns.Battlegrounds.ABLastTick.LastHordeCount ~= LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Bases ) then
					LVBM.Schedule(2, "LVBM.AddOns.Battlegrounds.OnEvent", "GetNewABTimes");		-- Try this because the GetScore 
															-- issnt Sync and this suxx hard !!!
				end
			end
		else 
			-- AB TimeLeft
			LVBM.EndStatusBarTimer("ABWINALLY");
			LVBM.EndStatusBarTimer("ABWINHORDE");
		end
		if( event == "GetNewABTimes" ) then

				AllyTime = ((2000 - LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Score) 
				            / LVBM.AddOns.Battlegrounds.ABResPerSec(LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Bases))
					    - (time()-LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Time);

				HordeTime = ((2000 - LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Score) 
				             / LVBM.AddOns.Battlegrounds.ABResPerSec(LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Bases))
					     - (time()-LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Time);

				-- LVBM.AddMsg("Horde: "..HordeTime.." Sec  -  Alliance: "..AllyTime.." Sec ");

				if( AllyTime > 5000 ) then 	AllyTime = 5000; end
				if( HordeTime > 5000 ) then 	HordeTime = 5000; end
			
				LVBM.AddOns.Battlegrounds.ABLastTick.LastAllyCount = LVBM.AddOns.Battlegrounds.ABLastTick["Alliance"].Bases; 
				LVBM.AddOns.Battlegrounds.ABLastTick.LastHordeCount = LVBM.AddOns.Battlegrounds.ABLastTick["Horde"].Bases;

				if( AllyTime > HordeTime ) then		-- Horde wins!
					if( LVBM.GetStatusBarTimerTimeLeft("ABWINALLY") ) then
						LVBM.UpdateStatusBarTimer("ABWINALLY", 0, HordeTime, "ABWINHORDE", true);

					elseif( LVBM.GetStatusBarTimerTimeLeft("ABWINHORDE") ) then
						LVBM.UpdateStatusBarTimer("ABWINHORDE", 0, HordeTime, nil, true);
					else
						LVBM.StartStatusBarTimer(HordeTime, "ABWINHORDE", nil, true);
					end
				else					-- Alliance wins!
					if( LVBM.GetStatusBarTimerTimeLeft("ABWINHORDE") ) then
						LVBM.UpdateStatusBarTimer("ABWINHORDE", 0, AllyTime, "ABWINALLY", true);

					elseif( LVBM.GetStatusBarTimerTimeLeft("ABWINALLY") ) then
						LVBM.UpdateStatusBarTimer("ABWINALLY", 0, AllyTime, nil, true);
					else
						LVBM.StartStatusBarTimer(AllyTime, "ABWINALLY", nil, true);
					end
				end
		end
		
		-------------------
		-- AV AutoTurnIn --
		-------------------
		if ((event == "GOSSIP_SHOW" or event=="QUEST_PROGRESS") and GetZoneText() == LVBM_BGMOD_LANG.AVZONE) then
			local target = UnitName("target");

			if( target == LVBM_BGMOD_LANG.NPC.SMITHREGZAR or target == LVBM_BGMOD_LANG.NPC.MURGOTDEEPFORGE ) then
				-- Open Quest to Smith or Murgot
				if (LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.ARMORSCRAPS) >= 20) then
					SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.NPC.PRIMALISTTHURLOGA) then
				local anzl = LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.SOLDIERSBLOOD);
				if (anzl >= 5) then		SelectGossipAvailableQuest(2);
				elseif (anzl > 0) then		SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.NPC.ARCHDRUIDRENFERAL) then
				local anzl = LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.STORMCRYSTAL);
				if (anzl >= 5) then		SelectGossipAvailableQuest(2);
				elseif (anzl > 0) then		SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.NPC.STORMPIKERAMRIDERCOMMANDER) then	-- Ram Riders
				if (LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.FROSTWOLFHIDE) > 0) then
					SelectGossipAvailableQuest(1);
				end

			elseif( target == LVBM_BGMOD_LANG.NPC.FROSTWOLFWOLFRIDERCOMMANDER) then	-- Wolf Riders
				if (LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.ALTERACRAMHIDE) > 0) then
					SelectGossipAvailableQuest(1);
				end
			end

		end
		if (event=="QUEST_PROGRESS" and GetZoneText() == LVBM_BGMOD_LANG.AVZONE) then
			local target = UnitName("target");

			if (target == LVBM_BGMOD_LANG.NPC.WINGCOMMANDERJEZTOR 
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.LIEUTENANTSFLESH) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.NPC.WINGCOMMANDERGUSE
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.SOLDIERSFLESH) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.NPC.WINGCOMMANDERMULVERICK
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.COMMANDERSFLESH) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.NPC.WINGCOMMANDERVIPORE
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.LIEUTENANTSMEDAL) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.NPC.WINDCOMMANDERSLIDORE
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.SOLDIERSMEDAL) == 0) then		return;

			elseif (target == LVBM_BGMOD_LANG.NPC.WINGCOMMANDERICHMAN
			   and LVBM.AddOns.Battlegrounds.GetItemCount(LVBM_BGMOD_LANG.ITEM.COMMANDERSMEDAL) == 0) then		return;

		   	end
			CompleteQuest();

		end
		if (event=="QUEST_COMPLETE" and GetZoneText() == LVBM_BGMOD_LANG.AVZONE) then
			local target = UnitName("target");
			for index,  value in LVBM_BGMOD_LANG.NPC do
				if (target == value) then
					GetQuestReward(0);
					LVBM.AddMsg(LVBM_BGMOD_LANG.THANKS);
				end
			end
		end


		-- ----------------- --
		-- Code from LeoLeal --
		-- modded by Nitram  --
		-- ----------------- --
		if (event == "CHAT_MSG_BG_SYSTEM_ALLIANCE") then
			for index, value in ipairs(LVBM_BGMOD_LANG.AB_TARGETS) do
				if string.find(arg1, value) then
					if string.find(arg1, LVBM_BGMOD_LANG["HASASSAULTED"]) or string.find(arg1, LVBM_BGMOD_LANG["CLAIMSTHE"]) then
						--Initiate a timer w/ value as text string for 60 seconds
						LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
						LVBM.StartStatusBarTimer(64,  "Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));

					elseif string.find(arg1, LVBM_BGMOD_LANG["HASDEFENDEDTHE"]) or string.find(arg1, LVBM_BGMOD_LANG["HASTAKENTHE"]) then
						--clear a timer for value
						if string.find(arg1, LVBM_BGMOD_LANG["HASTAKENTHE"]) then
							LVBM.Announce(string.format(LVBM_BGMOD_LANG.ALLI_TAKE_ANNOUNCE, LVBM.Capitalize(LVBM_BGMOD_LANG.AB_TARGETS[index])));
							oldFlashColor=LVBM.Options.FlashColor;
							LVBM.Options.FlashColor = "blue";
							LVBM.AddSpecialWarning("", false, true);
							LVBM.Options.FlashColor = oldFlashColor;
						end
						LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
						LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
					end
				end
			end
			
			-- WSG Capture Flag
			if (string.find(arg1, LVBM_BGMOD_LANG["HASCAPTURED"])) then
				oldFlashColor=LVBM.Options.FlashColor;
				LVBM.Options.FlashColor = "blue";
				LVBM.AddSpecialWarning("", false, true);
				LVBM.Options.FlashColor = oldFlashColor;
				LVBM.StartStatusBarTimer(23, "Flag respawn");
			end
			
			--Initial capture of Snowfall for horde
			if string.find(string.lower(arg1), string.lower(LVBM_BGMOD_EN_TARGET_AV[8])) then
				LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[8]);
				LVBM.StartStatusBarTimer(303,  "Alliance: "..LVBM_BGMOD_EN_TARGET_AV[8]);
			end
		elseif (event == "CHAT_MSG_BG_SYSTEM_HORDE") then
			for index, value in ipairs(LVBM_BGMOD_LANG.AB_TARGETS) do
				if string.find(arg1, value) then
					if string.find(arg1, LVBM_BGMOD_LANG["HASASSAULTED"]) or string.find(arg1, LVBM_BGMOD_LANG["CLAIMSTHE"]) then
						--Initiate a timer w/ value as text string for 60 seconds
						LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
						LVBM.StartStatusBarTimer(64, "Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
					elseif string.find(arg1, LVBM_BGMOD_LANG["HASDEFENDEDTHE"]) or string.find(arg1, LVBM_BGMOD_LANG["HASTAKENTHE"]) then
						--clear a timer for value
						if string.find(arg1, LVBM_BGMOD_LANG["HASTAKENTHE"]) then
							LVBM.Announce(string.format(LVBM_BGMOD_LANG.HORDE_TAKE_ANNOUNCE, LVBM.Capitalize(LVBM_BGMOD_LANG.AB_TARGETS[index])));
							oldFlashColor=LVBM.Options.FlashColor;
							LVBM.Options.FlashColor = "red";
							LVBM.AddSpecialWarning("", false, true);
							LVBM.Options.FlashColor = oldFlashColor;
						end
						LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
						LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]));
					end
				end
			end
			
			-- WSG Capture
			if (string.find(arg1,LVBM_BGMOD_LANG["HASCAPTURED"])) then
				oldFlashColor=LVBM.Options.FlashColor;
				LVBM.Options.FlashColor = "red";
				LVBM.AddSpecialWarning("", false, true);
				LVBM.Options.FlashColor = oldFlashColor;
				LVBM.StartStatusBarTimer(23, "Flag respawn");
			end
		
			--Initial capture of Snowfall for horde
			if string.find(string.lower(arg1), string.lower(LVBM_BGMOD_EN_TARGET_AV[8])) then
				LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[8]);
				LVBM.StartStatusBarTimer(303, "Horde: "..LVBM_BGMOD_EN_TARGET_AV[8]);
			end
			
		-- Alterac Valley Specific Yells
		elseif (event == "CHAT_MSG_MONSTER_YELL") then
			for index,  value in ipairs(LVBM_BGMOD_LANG["AV_TARGETS"]) do
				if string.find(string.lower(arg1), string.lower(value)) then

					if string.find(arg1, LVBM_BGMOD_LANG["UNDERATTACK"]) then
						--Initiate a timer w/ value as text string for 300 seconds
						if string.find(arg1, LVBM_BGMOD_LANG["HORDE"]) then 
							LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index]);
							LVBM.StartStatusBarTimer(303,  "Horde: "..LVBM_BGMOD_EN_TARGET_AV[index]);
						end
						if string.find(arg1, LVBM_BGMOD_LANG["ALLIANCE"]) then
							LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[index]);
							LVBM.StartStatusBarTimer(303,  "Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index]);
						end
					elseif string.find(arg1, LVBM_BGMOD_LANG["WASDESTROYED"]) or string.find(arg1, LVBM_BGMOD_LANG["WASTAKENBY"]) then
						--clear a timer for value
						if string.find(arg1, LVBM_BGMOD_LANG["ALLIANCE"]) then
							LVBM.Announce(string.format(LVBM_BGMOD_LANG.ALLI_TAKE_ANNOUNCE, value));
							oldFlashColor=LVBM.Options.FlashColor;
							LVBM.Options.FlashColor = "blue";
							LVBM.AddSpecialWarning("", false, true);
							LVBM.Options.FlashColor = oldFlashColor;
						end
						if string.find(arg1, LVBM_BGMOD_LANG["HORDE"]) then
							LVBM.Announce(string.format(LVBM_BGMOD_LANG.HORDE_TAKE_ANNOUNCE, value));
							oldFlashColor=LVBM.Options.FlashColor;
							LVBM.Options.FlashColor = "red";
							LVBM.AddSpecialWarning("", false, true);
							LVBM.Options.FlashColor = oldFlashColor;
						end
						LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index]);
						LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[index]);
					end
				end
			end

			--Ivus and Ice Lord
			if string.find(arg1,LVBM_BGMOD_LANG["IVUS"]) then 
				LVBM.StartStatusBarTimer(603,  "Ivus spawn");
			elseif string.find(string.lower(arg1),string.lower(LVBM_BGMOD_LANG["ICEY"])) then
				LVBM.StartStatusBarTimer(603,  "Ice spawn");
			end

		-- Begining Match Timers and End Matches
		elseif (event == "CHAT_MSG_BG_SYSTEM_NEUTRAL") then
			if (arg1 == LVBM_BGMOD_LANG["WSG_START60SEC"]
			 or arg1 == LVBM_BGMOD_LANG["AB_START60SEC"]
			 or arg1 == LVBM_BGMOD_LANG["AV_START60SEC"] ) then
					LVBM.EndStatusBarTimer("Begins");
					LVBM.StartStatusBarTimer(62, "Begins");

			elseif (arg1 == LVBM_BGMOD_LANG["WSG_START30SEC"]
			     or arg1 == LVBM_BGMOD_LANG["AB_START30SEC"]
			     or arg1 == LVBM_BGMOD_LANG["AV_START30SEC"] ) then
					LVBM.EndStatusBarTimer("Begins");
					LVBM.StartStatusBarTimer(32, "Begins");
			end

			-- Resets Timers when BGMatch Ends (Note that this is different than Leaving BG)
			if string.find(arg1, LVBM_BGMOD_LANG["WINS"]) then
				LVBM.EndStatusBarTimer("Begins");
				LVBM.EndStatusBarTimer("Flag respawn");
				for index, value in ipairs(LVBM_BGMOD_LANG.AB_TARGETS) do
					LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
					LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
				end
				for index, value in ipairs(LVBM_BGMOD_EN_TARGET_AV) do
					LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[index], true);
					LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index], true);
				end
			end

		-- Reset Timers when leaving BG
		elseif (event == "PLAYER_ENTERING_WORLD") then
			LVBM.EndStatusBarTimer("Begins");
			LVBM.EndStatusBarTimer("Flag respawn");
			for index, value in ipairs(LVBM_BGMOD_LANG.AB_TARGETS) do
				LVBM.EndStatusBarTimer("Horde: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
				LVBM.EndStatusBarTimer("Alliance: "..LVBM.Capitalize(LVBM_BGMOD_EN_TARGET_AB[index]), true);
			end
			for index, value in ipairs(LVBM_BGMOD_EN_TARGET_AV) do
				LVBM.EndStatusBarTimer("Horde: "..LVBM_BGMOD_EN_TARGET_AV[index], true);
				LVBM.EndStatusBarTimer("Alliance: "..LVBM_BGMOD_EN_TARGET_AV[index], true);
			end
		end
	end, 	
	

};


